@echo off
setlocal ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

set PATCH_FILE="%~dp0PuzzlerWorld2.patch"
set PATCH_EXE="%~dp0apatch.exe"

if not exist !PATCH_FILE! (
  echo Cannot find PuzzlerWorld2.patch, make sure you extracted all the files and put them in the same folder.
  pause
  goto :eof
)
if not exist !PATCH_EXE! (
  echo Cannot find apatch.exe, make sure you extracted all the files and put them in the same folder.
  pause
  goto :eof
)


set GAME_FILE=Puzzler World 2.exe
set GAME_FOLDER=%~dp0
if not exist "!GAME_FOLDER!!GAME_FILE!" for /F "usebackq tokens=2*" %%F in (`reg query HKCU\Software\Valve\Steam /v SteamPath`) do if "%%F" EQU "REG_SZ" set GAME_FOLDER=%%~G\steamapps\common\PuzzlerWorld2\
echo.
echo Using game folder !GAME_FOLDER!
echo.

set GAME_EXE="!GAME_FOLDER!!GAME_FILE!"
set TEMP_EXE="!GAME_FOLDER!!GAME_FILE!.temp"
set BACKUP_EXE="!GAME_FOLDER!!GAME_FILE!.orig"

if not exist !GAME_EXE! (
  echo Cannot find !GAME_FILE!, try moving the files to the game folder and rerunning.
  pause
  goto :eof
)
if exist !TEMP_EXE! (
  echo Temp file !GAME_FILE!.temp already exists, aborting.
  pause
  goto :eof
)
if exist !BACKUP_EXE! (
  echo Backup file !GAME_FILE!.orig already exists, aborting.
  pause
  goto :eof
)


copy !GAME_EXE! !BACKUP_EXE! 1>nul
if not exist !BACKUP_EXE! (
  echo Cannot create backup file !GAME_FILE!.orig, aborting.
  pause
  goto :eof
)


!PATCH_EXE! !PATCH_FILE! !BACKUP_EXE! !TEMP_EXE!
echo.
if ERRORLEVEL 1 (
  echo Error reported by patcher, aborting.
  pause
  del !BACKUP_EXE! 1>nul 2>nul
  del !TEMP_EXE! 1>nul 2>nul
  goto :eof
)


del !GAME_EXE! 1>nul
if exist !GAME_EXE! (
  echo Unable to remove old !GAME_FILE!, aborting.
  pause
  del !BACKUP_EXE! 1>nul 2>nul
  del !TEMP_EXE! 1>nul 2>nul
  goto :eof
)


ren !TEMP_EXE! "!GAME_FILE!" 1>nul
if not exist !GAME_EXE! (
  echo Unable to rename new !GAME_FILE!, aborting.
  pause
  ren !BACKUP_EXE! "!GAME_FILE!" 1>nul 2>nul
  del !TEMP_EXE! 1>nul 2>nul
  goto :eof
)


echo.
echo Patch successful, enjoy.
pause
